// Type definitions for @ag-grid-community/core v23.2.0
// Project: http://www.ag-grid.com/
// Definitions by: Niall Crosby <https://github.com/ag-grid/>
export declare const _: {
    utf8_encode(s: string): string;
    camelCaseToHyphen(str: string): string;
    hyphenToCamelCase(str: string): string;
    capitalise(str: string): string;
    escape(toEscape: string): string;
    camelCaseToHumanText(camelCase: string): string;
    convertToSet<T>(list: T[]): Set<T>;
    sortRowNodesByOrder(rowNodes: import("../main").RowNode[], rowNodeOrder: {
        [id: string]: number;
    }): void;
    traverseNodesWithKey(nodes: import("../main").RowNode[], callback: (node: import("../main").RowNode, key: string) => void): void;
    iterateObject<T_1>(object: {
        [p: string]: T_1;
    } | T_1[], callback: (key: string, value: T_1) => void): void;
    cloneObject<T_2>(object: T_2): T_2;
    deepCloneObject<T_3>(object: T_3): T_3;
    getProperty<T_4, K extends keyof T_4>(object: T_4, key: K): any;
    setProperty<T_5, K_1 extends keyof T_5>(object: T_5, key: K_1, value: any): void;
    copyPropertiesIfPresent<S, T_6 extends S, K_2 extends keyof S>(source: S, target: T_6, ...properties: K_2[]): void;
    copyPropertyIfPresent<S_1, T_7 extends S_1, K_3 extends keyof S_1>(source: S_1, target: T_7, property: K_3, transform?: (value: S_1[K_3]) => any): void;
    getAllKeysInObjects(objects: any[]): string[];
    mergeDeep(dest: any, source: any, copyUndefined?: boolean): void;
    assign<T_8, U>(target: T_8, source: U): T_8 & U;
    assign<T_9, U_1, V>(target: T_9, source1: U_1, source2: V): T_9 & U_1 & V;
    assign<T_10, U_2, V_1, W>(target: T_10, source1: U_2, source2: V_1, source3: W): T_10 & U_2 & V_1 & W;
    missingOrEmptyObject(value: any): boolean;
    get(source: any, expression: string, defaultValue: any): any;
    set(target: any, expression: string, value: any): void;
    deepFreeze(object: any): any;
    getValueUsingField(data: any, field: string, fieldContainsDots: boolean): any;
    padStart(value: number, totalStringSize: number): string;
    createArrayOfNumbers(first: number, last: number): number[];
    isNumeric(value: any): boolean;
    getMaxSafeInteger(): number;
    cleanNumber(value: any): number;
    decToHex(number: number, bytes: number): string;
    formatNumberTwoDecimalPlacesAndCommas(value: number): string;
    formatNumberCommas(value: number): string;
    sum(values: number[]): number;
    normalizeWheel(event: any): any;
    isLeftClick(mouseEvent: MouseEvent): boolean;
    areEventsNear(e1: Touch | MouseEvent, e2: Touch | MouseEvent, pixelCount: number): boolean;
    keys<T_11>(map: Map<T_11, any>): T_11[];
    isKeyPressed(event: KeyboardEvent, keyToCheck: number): boolean;
    isCharacterKey(event: KeyboardEvent): boolean;
    isEventFromPrintableCharacter(event: KeyboardEvent): boolean;
    isUserSuppressingKeyboardEvent(gridOptionsWrapper: import("../gridOptionsWrapper").GridOptionsWrapper, keyboardEvent: KeyboardEvent, rowNode: import("../main").RowNode, column: import("../main").Column, editing: boolean): boolean;
    createIcon(iconName: string, gridOptionsWrapper: import("../gridOptionsWrapper").GridOptionsWrapper, column: import("../main").Column): HTMLElement;
    createIconNoSpan(iconName: string, gridOptionsWrapper: import("../gridOptionsWrapper").GridOptionsWrapper, column?: import("../main").Column, forceCreate?: boolean): HTMLElement;
    iconNameClassMap: {
        [key: string]: string;
    };
    makeNull<T_12>(value?: T_12): T_12;
    exists<T_13>(value: T_13, allowEmptyString?: boolean): boolean;
    missing<T_14>(value: T_14): boolean;
    missingOrEmpty<T_15>(value?: string | T_15[]): boolean;
    toStringOrNull(value: any): string;
    referenceCompare<T_16>(left: T_16, right: T_16): boolean;
    jsonEquals<T1, T2>(val1: T1, val2: T2): boolean;
    defaultComparator(valueA: any, valueB: any, accentedCompare?: boolean): number;
    find<T_17>(collection: {
        [id: string]: T_17;
    } | T_17[], predicate: string | boolean | ((item: T_17) => boolean), value?: any): T_17;
    values<T_18>(object: {
        [key: string]: T_18;
    } | Set<T_18> | Map<any, T_18>): T_18[];
    fuzzyCheckStrings(inputValues: string[], validValues: string[], allSuggestions: string[]): {
        [p: string]: string[];
    };
    fuzzySuggestions(inputValue: string, allSuggestions: string[], hideIrrelevant?: boolean, weighted?: true): string[];
    get_bigrams(from: string): any[];
    string_distances(str1: string, str2: string): number;
    string_weighted_distances(str1: string, str2: string): number;
    doOnce(func: () => void, key: string): void;
    getFunctionParameters(func: any): any;
    isFunction(val: any): boolean;
    executeInAWhile(funcs: Function[]): void;
    executeNextVMTurn(funcs: Function[]): void;
    executeAfter(funcs: Function[], milliseconds?: number): void;
    debounce(func: (...args: any[]) => void, wait: number, immediate?: boolean): (...args: any[]) => void;
    compose(...fns: Function[]): (arg: any) => any;
    callIfPresent(func: Function): void;
    stopPropagationForAgGrid(event: Event): void;
    isStopPropagationForAgGrid(event: Event): boolean;
    getCellCompForEvent(gridOptionsWrapper: import("../gridOptionsWrapper").GridOptionsWrapper, event: Event): import("../main").CellComp;
    addChangeListener(element: HTMLElement, listener: EventListener): void;
    getTarget(event: Event): Element;
    isElementInEventPath(element: HTMLElement, event: Event): boolean;
    createEventPath(event: Event): EventTarget[];
    addAgGridEventPath(event: Event): void;
    getEventPath(event: Event): EventTarget[];
    addSafePassiveEventListener(frameworkOverrides: import("../main").IFrameworkOverrides, eElement: HTMLElement, event: string, listener: (event?: any) => void): void;
    isEventSupported: (eventName: any) => boolean;
    addCssClass(element: HTMLElement, className: string): HTMLElement;
    removeCssClass(element: HTMLElement, className: string): void;
    addOrRemoveCssClass(element: HTMLElement, className: string, addOrRemove: boolean): void;
    radioCssClass(element: HTMLElement, elementClass: string, otherElementClass?: string): void;
    containsClass(element: HTMLElement, className: string): boolean;
    setDisplayed(element: HTMLElement, displayed: boolean): void;
    setVisible(element: HTMLElement, visible: boolean): void;
    setDisabled(element: HTMLElement, disabled: boolean): void;
    isElementChildOfClass(element: HTMLElement, cls: string, maxNest?: number): boolean;
    getElementSize(el: HTMLElement): {
        height: number;
        width: number;
        paddingTop: number;
        paddingRight: number;
        paddingBottom: number;
        paddingLeft: number;
        marginTop: number;
        marginRight: number;
        marginBottom: number;
        marginLeft: number;
        boxSizing: string;
    };
    getInnerHeight(el: HTMLElement): number;
    getInnerWidth(el: HTMLElement): number;
    getAbsoluteHeight(el: HTMLElement): number;
    getAbsoluteWidth(el: HTMLElement): number;
    getScrollLeft(element: HTMLElement, rtl: boolean): number;
    setScrollLeft(element: HTMLElement, value: number, rtl: boolean): void;
    clearElement(el: HTMLElement): void;
    removeElement(parent: HTMLElement, cssSelector: string): void;
    removeFromParent(node: Element): void;
    isVisible(element: HTMLElement): boolean;
    loadTemplate(template: string): HTMLElement;
    appendHtml(eContainer: HTMLElement, htmlTemplate: string): void;
    getElementAttribute(element: any, attributeName: string): string;
    offsetHeight(element: HTMLElement): number;
    offsetWidth(element: HTMLElement): number;
    ensureDomOrder(eContainer: HTMLElement, eChild: HTMLElement, eChildBefore: HTMLElement): void;
    setDomChildOrder(eContainer: HTMLElement, orderedChildren: HTMLElement[]): void;
    insertTemplateWithDomOrder(eContainer: HTMLElement, htmlTemplate: string, eChildBefore: HTMLElement): HTMLElement;
    prependDC(parent: HTMLElement, documentFragment: DocumentFragment): void;
    addStylesToElement(eElement: any, styles: any): void;
    isHorizontalScrollShowing(element: HTMLElement): boolean;
    isVerticalScrollShowing(element: HTMLElement): boolean;
    setElementWidth(element: HTMLElement, width: string | number): void;
    setFixedWidth(element: HTMLElement, width: string | number): void;
    setElementHeight(element: HTMLElement, height: string | number): void;
    setFixedHeight(element: HTMLElement, height: string | number): void;
    formatSize(size: string | number): string;
    isNode(o: any): boolean;
    isElement(o: any): boolean;
    isNodeOrElement(o: any): boolean;
    copyNodeList(nodeList: NodeList): Node[];
    iterateNamedNodeMap(map: NamedNodeMap, callback: (key: string, value: string) => void): void;
    setCheckboxState(eCheckbox: HTMLInputElement, state: any): void;
    serialiseDate(date: Date, includeTime?: boolean, separator?: string): string;
    parseDateTimeFromString(value: string): Date;
    stringToArray(strData: string, delimiter?: string): string[][];
    isBrowserIE(): boolean;
    isBrowserEdge(): boolean;
    isBrowserSafari(): boolean;
    isBrowserChrome(): boolean;
    isBrowserFirefox(): boolean;
    isIOSUserAgent(): boolean;
    getTabIndex(el: HTMLElement): string;
    getMaxDivHeight(): number;
    getScrollbarWidth(): number;
    hasOverflowScrolling(): boolean;
    getBodyWidth(): number;
    getBodyHeight(): number;
    firstExistingValue<A>(...values: A[]): A;
    anyExists(values: any[]): boolean;
    existsAndNotEmpty<T_19>(value?: T_19[]): boolean;
    last<T_20>(arr: T_20[]): T_20;
    areEqual<T_21>(a: T_21[], b: T_21[], comparator?: (a: T_21, b: T_21) => boolean): boolean;
    compareArrays(array1?: any[], array2?: any[]): boolean;
    shallowCompare(arr1: any[], arr2: any[]): boolean;
    sortNumerically(array: number[]): number[];
    removeRepeatsFromArray<T_22>(array: T_22[], object: T_22): void;
    removeFromArray<T_23>(array: T_23[], object: T_23): void;
    removeAllFromArray<T_24>(array: T_24[], toRemove: T_24[]): void;
    insertIntoArray<T_25>(array: T_25[], object: T_25, toIndex: number): void;
    insertArrayIntoArray<T_26>(dest: T_26[], src: T_26[], toIndex: number): void;
    moveInArray<T_27>(array: T_27[], objectsToMove: T_27[], toIndex: number): void;
    includes<T_28>(array: T_28[], value: T_28): boolean;
    flatten(arrayOfArrays: any[]): any[];
    pushAll<T_29>(target: T_29[], source: T_29[]): void;
    toStrings<T_30>(array: T_30[]): string[];
    findIndex<T_31>(collection: T_31[], predicate: (item: T_31, idx: number, collection: T_31[]) => boolean): number;
    every<T_32>(list: T_32[], predicate: (value: T_32, index: number) => boolean): boolean;
    some<T_33>(list: T_33[], predicate: (value: T_33, index: number) => boolean): boolean;
    forEach<T_34>(list: T_34[], action: (value: T_34, index: number) => void): void;
    map<T_35, V_2>(list: T_35[], process: (value: T_35, index: number) => V_2): V_2[];
    filter<T_36>(list: T_36[], predicate: (value: T_36, index: number) => boolean): T_36[];
    reduce<T_37, V_3>(list: T_37[], step: (acc: V_3, value: T_37, index: number) => V_3, initial: V_3): V_3;
    forEachSnapshotFirst<T_38>(list: T_38[], callback: (item: T_38) => void): void;
    getNameOfClass(theClass: any): string;
    findLineByLeastSquares(values: number[]): number[];
    cssStyleObjectToMarkup(stylesToUse: any): string;
    message(msg: string): void;
    bindCellRendererToHtmlElement(cellRendererPromise: import("./promise").Promise<import("../main").ICellRendererComp>, eTarget: HTMLElement): void;
};
